from db.MongoRepository import MongoRepository
import json

import logging
LOGGER = logging.getLogger(__name__)

class MessageHandler:
    _mongo_repo = None

    def __init__(self):
        self._mongo_repo = MongoRepository()

    def handle_generic(self, body):
        LOGGER.info(f"Received message: {body}")
        message = json.loads(body)
        if not 'type' in message:
            LOGGER.warning(f"Message has no type field -> ignored")
            return
        
        if message['type'] == 'blockchain-transaction':
            self.handle_blockchain_transaction(json.loads(message['content']))
            
    def handle_blockchain_transaction(self, transaction):
        self._mongo_repo.insert_trace(transaction)
